Index: imaps-frontend/src/components/Modals/StairsModal/StairsModal.jsx
===================================================================
--- imaps-frontend/src/components/Modals/StairsModal/StairsModal.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Modals/StairsModal/StairsModal.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -33,4 +33,5 @@
         setIsOpen(true);
         console.log(roomObj.info.selectedPins, "Loaded pins on modal open");
+        event.detail.map.detachKeyPressEventListeners();
     },"openStairsModalEvent")
 
Index: imaps-frontend/src/components/Profile/Profile.jsx
===================================================================
--- imaps-frontend/src/components/Profile/Profile.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/Profile/Profile.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -1,4 +1,5 @@
-import React, { useState, useRef, useEffect, useContext } from "react";
-import { useNavigate, Link } from "react-router-dom";
+import React, { useState, useRef, useEffect } from "react";
+import ReactDOM from "react-dom";
+import { useNavigate } from "react-router-dom";
 import profile from "../../assets/person_icon.png";
 import styles from "./Profile.module.css";
@@ -8,5 +9,5 @@
     const { username, isAuthenticated } = useAppContext();
     const [open, setOpen] = useState(false);
-    const menuRef = useRef(null);
+    const [menuPosition, setMenuPosition] = useState({ top: 0, left: 0 });
     const imgRef = useRef(null);
     const navigate = useNavigate();
@@ -16,8 +17,6 @@
     useEffect(() => {
         const handleClickOutside = (e) => {
-            if (menuRef.current && imgRef.current) {
-                if (!menuRef.current.contains(e.target) && !imgRef.current.contains(e.target)) {
-                    setOpen(false);
-                }
+            if (imgRef.current && !imgRef.current.contains(e.target)) {
+                setOpen(false);
             }
         };
@@ -30,4 +29,15 @@
     }, []);
 
+    const toggleMenu = () => {
+        if (imgRef.current) {
+            const rect = imgRef.current.getBoundingClientRect();
+            setMenuPosition({
+                top: rect.bottom + window.scrollY,
+                left: rect.left + window.scrollX,
+            });
+        }
+        setOpen(!open);
+    };
+
     const handleMenuClick = (menu) => {
         if (menu === "My Maps") {
@@ -36,32 +46,54 @@
             localStorage.removeItem("token");
             window.location.reload();
+        } else if (menu === "Login") {
+            navigate("/Login");
         }
         setOpen(false);
     };
 
+    const renderDropdown = () => {
+        if (!open) return null;
+
+        return ReactDOM.createPortal(
+            <div
+                className={styles.dropdownMenu}
+                style={{
+                    position: "absolute",
+                    top: menuPosition.top,
+                    left: menuPosition.left,
+                }}
+            >
+                {isAuthenticated && <div className={styles.username}>{username}</div>}
+                <ul className={styles.menuList}>
+                    {menus.map((menu) => (
+                        <li
+                            key={menu}
+                            className={styles.menuItem}
+                            onClick={() => handleMenuClick(menu)}
+                        >
+                            {menu}
+                        </li>
+                    ))}
+                </ul>
+            </div>,
+            document.body
+        );
+    };
+
     return (
-        <div className={position === "fixed" ? styles.fixedProfileContainer : styles.inlineProfileContainer}>
+        <div
+            className={
+                position === "fixed" ? styles.fixedProfileContainer : styles.inlineProfileContainer
+            }
+        >
             <div className={styles.profileWrapper}>
-                <div className={styles.profileIconContainer} onClick={() => setOpen(!open)}>
-                    <img src={profile} alt="profile" className={styles.profileImage} ref={imgRef} />
+                <div
+                    className={styles.profileIconContainer}
+                    onClick={toggleMenu}
+                    ref={imgRef}
+                >
+                    <img src={profile} alt="profile" className={styles.profileImage} />
                 </div>
-                {open && (
-                    <div ref={menuRef} className={styles.dropdownMenu}>
-                        {isAuthenticated && <div className={styles.username}>{username}</div>}
-                        <ul className={styles.menuList}>
-                            {menus.map((menu) =>
-                                menu === "Login" ? (
-                                    <li key={menu} className={styles.menuItem}>
-                                        <Link to="/login" className={styles.linkStyle}>{menu}</Link>
-                                    </li>
-                                ) : (
-                                    <li key={menu} onClick={() => handleMenuClick(menu)} className={styles.menuItem}>
-                                        {menu}
-                                    </li>
-                                )
-                            )}
-                        </ul>
-                    </div>
-                )}
+                {renderDropdown()}
             </div>
         </div>
Index: imaps-frontend/src/components/PublishForm/PublishForm.jsx
===================================================================
--- imaps-frontend/src/components/PublishForm/PublishForm.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/PublishForm/PublishForm.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -15,4 +15,6 @@
     );
     const [errors, setErrors] = useState({});
+    const [denyReason, setDenyReason] = useState('');
+    const [isDenying, setIsDenying] = useState(false);
 
     const mapTypeOptions = ['Hospital', 'Faculty', 'House', 'Other'];
@@ -42,4 +44,13 @@
             onSubmit(form);
         }
+    };
+
+    const handleDeny = () => {
+        if (!denyReason.trim()) {
+            alert('Please provide a reason for denial.');
+            return;
+        }
+        onDeny(form.id, form.mapName, denyReason);
+        setIsDenying(false);
     };
 
@@ -130,5 +141,8 @@
                                 <button
                                     className={styles.cancelButton}
-                                    onClick={onCancel}
+                                    onClick={() => {
+                                        setIsDenying(false);
+                                        onCancel();
+                                    }}
                                 >
                                     Cancel
@@ -136,5 +150,5 @@
                                 <button
                                     className={styles.approveButton}
-                                    onClick={() => onApprove(form.id,form.mapName)}
+                                    onClick={() => onApprove(form.id, form.mapName)}
                                 >
                                     Approve
@@ -142,9 +156,26 @@
                                 <button
                                     className={styles.denyButton}
-                                    onClick={() => onDeny(form.id,form.mapName,"Reason")}
+                                    onClick={() => setIsDenying(true)}
                                 >
                                     Deny
                                 </button>
                             </div>
+                            {isDenying && (
+                                <div className={styles.denyReason}>
+                                    <textarea className={styles.denyReasonTextArea}
+                                        placeholder="Enter reason for denial..."
+                                        value={denyReason}
+                                        onChange={(e) => setDenyReason(e.target.value)}
+                                    />
+                                    <div className={styles.buttonGroup}>
+                                        <button
+                                            className={styles.denySubmitButton}
+                                            onClick={handleDeny}
+                                        >
+                                            Submit
+                                        </button>
+                                    </div>
+                                </div>
+                            )}
                         </div>
                     )}
Index: imaps-frontend/src/components/Report/Report.jsx
===================================================================
--- imaps-frontend/src/components/Report/Report.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/components/Report/Report.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,80 @@
+import React, { useState } from "react";
+import styles from "./Report.module.css";
+import report_icon from "../../assets/report_icon.png";
+import {useAppContext} from "../AppContext/AppContext.jsx";
+import HttpService from "../../scripts/net/HttpService.js";
+import config from "../../scripts/net/netconfig.js";
+
+const Report = ({mapName}) => {
+    const [isModalOpen, setIsModalOpen] = useState(false);
+    const [topic, setTopic] = useState("");
+    const [description, setDescription] = useState("");
+    const {username} = useAppContext();
+
+    const handleSubmit = async () => {
+        if (!topic.trim() || !description.trim()) {
+            alert("Please fill in both fields.");
+            return;
+        }
+
+        let httpService = new HttpService(true);
+        let payload = {
+            username: username,
+            mapName: mapName,
+            subject: topic,
+            content: description,
+        }
+
+        let response = await httpService.post(config.view_maps.add_report, payload);
+
+        setTopic("")
+        setDescription("")
+        setIsModalOpen(false)
+    }
+
+
+    const handleOutsideClick = (e) => {
+        if (e.target.classList.contains(styles.modalBackground)) {
+            setIsModalOpen(false);
+        }
+    };
+
+    return (
+        <div>
+            <button className={styles.reportButton} onClick={() => setIsModalOpen(true)}>
+                <img src={report_icon} alt="Report Icon" className={styles.reportIcon} />
+            </button>
+
+            {isModalOpen && (
+                <div className={styles.modalBackground} onClick={handleOutsideClick}>
+                    <div className={styles.modalContent}>
+                        <h2>Report Issue</h2>
+                        <input
+                            type="text"
+                            placeholder="Topic"
+                            value={topic}
+                            onChange={(e) => setTopic(e.target.value)}
+                            className={styles.inputField}
+                        />
+                        <textarea
+                            placeholder="Description"
+                            value={description}
+                            onChange={(e) => setDescription(e.target.value)}
+                            className={styles.textareaField}
+                        ></textarea>
+                        <div className={styles.buttonGroup}>
+                            <button onClick={handleSubmit} className={styles.submitButton}>
+                                Submit
+                            </button>
+                            <button onClick={() => setIsModalOpen(false)} className={styles.cancelButton}>
+                                Cancel
+                            </button>
+                        </div>
+                    </div>
+                </div>
+            )}
+        </div>
+    );
+};
+
+export default Report;
Index: imaps-frontend/src/components/RoomInfoPanel/RoomInfoPanel.jsx
===================================================================
--- imaps-frontend/src/components/RoomInfoPanel/RoomInfoPanel.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/RoomInfoPanel/RoomInfoPanel.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -56,4 +56,5 @@
                 Navigate
               </button>
+              <p style={{fontSize: '0.8em'}}><i>From Main Entrance</i></p>
             </>
         ) : (
Index: imaps-frontend/src/components/SearchBar/SearchBar.jsx
===================================================================
--- imaps-frontend/src/components/SearchBar/SearchBar.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/components/SearchBar/SearchBar.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -6,5 +6,12 @@
 import styles from "./SearchBar.module.css";
 
-function SearchBar({ map, handleDirectionsSubmit, setIsPanelOpen, setSelectedRoom, availableShapes,handleFloorChange }) {
+function SearchBar({
+                     map,
+                     handleDirectionsSubmit,
+                     setIsPanelOpen,
+                     setSelectedRoom,
+                     availableShapes,
+                     handleFloorChange,
+                   }) {
   const [isExpanded, setIsExpanded] = useState(false);
   const [from, setFrom] = useState("");
@@ -14,25 +21,40 @@
   const [dropdownVisible, setDropdownVisible] = useState(false);
   const [inputFieldType, setInputFieldType] = useState("");
-  const dropdownRef = useRef(null);
-
-  const toggleExpanded = () => {
-    setIsExpanded(!isExpanded);
-  };
-
-  function searchRoom() {
-    let foundRoom = availableShapes.find(sh => sh.info.name === from)
-    console.log("map fnum",map.floorNum)
-    if(foundRoom.floorNum !== map.floorNum){
+
+  const wrapperRef = useRef(null);
+  const dropdownContainerRef = useRef(null);
+  const activeInputRef = useRef(null); // Track the currently focused input field
+
+  const toggleExpanded = () => setIsExpanded(!isExpanded);
+
+  const handleClickOutside = (event) => {
+    if (
+        wrapperRef.current &&
+        !wrapperRef.current.contains(event.target) &&
+        dropdownContainerRef.current &&
+        !dropdownContainerRef.current.contains(event.target)
+    ) {
+      setDropdownVisible(false);
+    }
+  };
+
+  useEffect(() => {
+    document.addEventListener("mousedown", handleClickOutside);
+    return () => {
+      document.removeEventListener("mousedown", handleClickOutside);
+    };
+  }, []);
+
+  const searchRoom = () => {
+    const foundRoom = availableShapes.find((sh) => sh.info.name === from);
+    if (foundRoom && foundRoom.floorNum !== map.floorNum) {
       handleFloorChange(foundRoom.floorNum);
     }
-
-
-    console.log("FOUND ROOM: " + foundRoom)
     map.highlightShape(from);
     setSelectedRoom(foundRoom);
     setIsPanelOpen(true);
-  }
-
-  const handleInputFocus = (field) => {
+  };
+
+  const handleInputFocus = (field, inputRef) => {
     if (availableOptions.length === 0 && map) {
       setAvailableOptions(
@@ -42,6 +64,7 @@
       );
     }
+    setInputFieldType(field);
     setDropdownVisible(true);
-    setInputFieldType(field);
+    activeInputRef.current = inputRef; // Set the active input ref
   };
 
@@ -69,13 +92,18 @@
     if (!dropdownVisible || filteredOptions.length === 0) return null;
 
-    const position = dropdownRef.current?.getBoundingClientRect() || { top: 0, left: 0, width: 0 };
+    const position = activeInputRef.current?.getBoundingClientRect() || {
+      top: 0,
+      left: 0,
+      width: 0,
+    };
 
     return ReactDOM.createPortal(
         <ul
+            ref={dropdownContainerRef}
             className={styles.dropdown}
             style={{
               position: "absolute",
-              top: position.top + position.height,
-              left: position.left,
+              top: position.top + position.height + window.scrollY,
+              left: position.left + window.scrollX,
               width: position.width,
             }}
@@ -91,10 +119,10 @@
           ))}
         </ul>,
-        document.body // Portal renders outside the parent hierarchy
+        document.body
     );
   };
 
   return (
-      <div className={styles.wrapper}>
+      <div className={styles.wrapper} ref={wrapperRef}>
         {!isExpanded ? (
             <div className={styles.searchBar}>
@@ -104,6 +132,5 @@
                   placeholder="Search location"
                   aria-label="Search"
-                  ref={dropdownRef} // Attach the input to calculate dropdown position
-                  onFocus={() => handleInputFocus("from")}
+                  onFocus={(e) => handleInputFocus("from", e.target)}
                   onChange={handleInputChange(setFrom)}
                   value={from}
@@ -111,8 +138,16 @@
               {renderDropdown()}
               <div className={styles.buttons}>
-                <button type="button" className={styles.iconButton} onClick={searchRoom}>
+                <button
+                    type="button"
+                    className={styles.iconButton}
+                    onClick={searchRoom}
+                >
                   <img src={searchIcon} alt="Search Icon" />
                 </button>
-                <button type="button" className={styles.iconButton} onClick={toggleExpanded}>
+                <button
+                    type="button"
+                    className={styles.iconButton}
+                    onClick={toggleExpanded}
+                >
                   <img src={routeIcon} alt="Route Icon" />
                 </button>
@@ -127,8 +162,7 @@
                     aria-label="From"
                     value={from}
-                    onFocus={() => handleInputFocus("from")}
+                    onFocus={(e) => handleInputFocus("from", e.target)}
                     onChange={handleInputChange(setFrom)}
                     className={styles.inputField}
-                    ref={inputFieldType === "from" ? dropdownRef : null}
                 />
                 <input
@@ -137,8 +171,7 @@
                     aria-label="To"
                     value={to}
-                    onFocus={() => handleInputFocus("to")}
+                    onFocus={(e) => handleInputFocus("to", e.target)}
                     onChange={handleInputChange(setTo)}
                     className={styles.inputField}
-                    ref={inputFieldType === "to" ? dropdownRef : null}
                 />
                 {renderDropdown()}
@@ -152,5 +185,9 @@
                   <img src={searchIcon} alt="Submit Directions" />
                 </button>
-                <button type="button" className={styles.iconButton} onClick={toggleExpanded}>
+                <button
+                    type="button"
+                    className={styles.iconButton}
+                    onClick={toggleExpanded}
+                >
                   <img src={closeIcon} alt="Close Icon" />
                 </button>
Index: imaps-frontend/src/main.jsx
===================================================================
--- imaps-frontend/src/main.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/main.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -4,4 +4,9 @@
 import './index.css'
 
+if (typeof GestureEvent === "undefined") {
+    window.GestureEvent = class GestureEvent {};
+}
+
+
 ReactDOM.createRoot(document.getElementById('root')).render(
    <App />
Index: imaps-frontend/src/pages/AdminPage/AdminPage.jsx
===================================================================
--- imaps-frontend/src/pages/AdminPage/AdminPage.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/pages/AdminPage/AdminPage.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -11,4 +11,5 @@
 import Profile from "../../components/Profile/Profile.jsx";
 import Toast from "../../components/Toast/Toast.jsx";
+import ListReports from "../../components/ListReports/ListReports.jsx";
 
 const renderTile = ({data, isDragging}, handleApprove, handleDeny, openMapInfoModal, openPublishForm) => (
@@ -82,5 +83,5 @@
                 gmaps_url: elem.gmaps_url,
                 image_url: card,
-            })).filter((tile) => tile.status === "INVALID");
+            })).filter((tile) => tile.status === "PENDING");
 
             setPendingMaps(mapTiles);
@@ -145,5 +146,5 @@
 
         try {
-            await httpService.post(url, formData); // Assuming formData contains all required fields
+            await httpService.post(url, formData);
             setPendingMaps((prev) => prev.filter((map) => map.mapName !== formData.mapName));
             alert(`Map "${formData.mapName}" published successfully.`);
@@ -187,4 +188,5 @@
             <Profile></Profile>
             <h1>Pending Maps for Approval</h1>
+            <hr/>
 
             {publishFormMap && (
@@ -210,4 +212,5 @@
                 />
             </div>
+            <hr/>
             {isMapInfoModalOpen && (
                 <MapInfoModal
@@ -223,5 +226,6 @@
             )}
             {toastMessage && <Toast message={toastMessage} type={toastType} onClose={() => setToastMessage(null)}/>}
-
+        <hr/>
+            <ListReports></ListReports>
         </div>
     );
Index: imaps-frontend/src/pages/AuthCallback.jsx
===================================================================
--- imaps-frontend/src/pages/AuthCallback.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/pages/AuthCallback.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -0,0 +1,18 @@
+import {useEffect} from "react";
+import {useLocation, useNavigate} from "react-router-dom";
+import {useAppContext} from "../components/AppContext/AppContext.jsx";
+
+export function AuthCallback(){
+    const location = useLocation();
+    const navigate = useNavigate();
+    const {setUsername,setIsAuthenticated} = useAppContext()
+    useEffect(() => {
+        const searchParams = new URLSearchParams(location.search);
+        const token = searchParams.get('token');
+        const username = searchParams.get('username');
+        localStorage.setItem("token",token)
+        setIsAuthenticated(true)
+        setUsername(username)
+        navigate("/")
+    }, []);
+}
Index: imaps-frontend/src/pages/BrowseMaps/BrowseMaps.jsx
===================================================================
--- imaps-frontend/src/pages/BrowseMaps/BrowseMaps.jsx	(revision 0c6b92add4cfaedcb91bcd37b45849f142f7d152)
+++ imaps-frontend/src/pages/BrowseMaps/BrowseMaps.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
@@ -1,27 +1,28 @@
 import styles from "./Maps.module.css";
 import "react-tiles-dnd/esm/index.css";
-import { TilesContainer } from "react-tiles-dnd";
-import { Link } from "react-router-dom";
+import {TilesContainer} from "react-tiles-dnd";
+import {Link} from "react-router-dom";
 import card from "../../assets/card-map.png";
 import star_icon from "../../assets/star_icon.png"; // Unfilled star icon
 import star_filled_icon from "../../assets/star_filled_icon.png"; // Filled star icon
-import { useEffect, useState } from "react";
+import {useEffect, useState} from "react";
 import HttpService from "../../scripts/net/HttpService.js";
 import Logo from "../../components/Logo/Logo.jsx";
 import Profile from "../../components/Profile/Profile.jsx";
 import config from "../../scripts/net/netconfig.js";
-import { useAppContext } from "../../components/AppContext/AppContext.jsx";
+import {useAppContext} from "../../components/AppContext/AppContext.jsx";
+import FilterMaps from "../../components/FilterMaps/FilterMaps.jsx";
 
 let loadedTiles = [];
 
-const renderTile = ({ data, isDragging, toggleFavorite }) => (
-    <div style={{ padding: "1rem", width: "100%", position: "relative" }}>
-        <Link to={`/Maps/${data.text}/View`} className={styles.linkStyle}>
+const renderTile = ({data, isDragging, toggleFavorite}) => (
+    <div style={{padding: "1rem", width: "100%", position: "relative"}}>
+        <Link to={`/Maps/View/${data.text}`} className={styles.linkStyle}>
             <div
                 className={`${styles.tile} ${isDragging ? styles.dragging : ""}`}
-                style={{ width: "100%", height: "100%" }}
+                style={{width: "100%", height: "100%"}}
             >
-                <img src={card} className={styles.imgStyle} alt="Map Thumbnail" />
-                <div style={{ fontFamily: "exo" }}>
+                <img src={card} className={styles.imgStyle} alt="Map Thumbnail"/>
+                <div style={{fontFamily: "exo"}}>
                     {data.text} {isDragging ? "DRAGGING" : null}
                 </div>
@@ -32,5 +33,5 @@
                 src={data.isFavorite ? star_filled_icon : star_icon}
                 alt="Favorite Icon"
-                style={{ width: "20px", height: "20px" }}
+                style={{width: "20px", height: "20px"}}
             />
         </div>
@@ -46,5 +47,7 @@
     const [searchTerm, setSearchTerm] = useState("");
     const [tiles, setTiles] = useState([]);
-    const { username, isAuthenticated } = useAppContext();
+    const {username, isAuthenticated} = useAppContext();
+    const [filter, setFilter] = useState("all")
+    const [mapFilters, setMapFilters] = useState([])
 
     useEffect(() => {
@@ -52,5 +55,5 @@
             const httpService = new HttpService();
             let mapTiles = [];
-
+            let mapTypes = ['Hospital', 'Faculty', 'House', 'Other'];
             if (isAuthenticated) {
                 // :D
@@ -63,9 +66,14 @@
                     rows: 1,
                     isFavorite: true,
+                    type: elem.mapType,
                 }));
 
+                console.log("TUKA")
                 // Load all maps
                 const allResp = await httpService.get(config.view_maps.display);
                 console.log("RESPONSE MAPS PUBLIC", allResp);
+
+                // mapTypes = allResp.filter(elem => elem.mapType != null && elem.mapType !== "").map(elem => elem.mapType);
+
 
                 const nonFavMapTiles = allResp
@@ -76,5 +84,7 @@
                         rows: 1,
                         isFavorite: false,
+                        type: elem.mapType,
                     }));
+
 
                 mapTiles = [...favMapTiles, ...nonFavMapTiles];
@@ -82,4 +92,5 @@
                 const allResp = await httpService.get(config.view_maps.display);
                 console.log("RESPONSE MAPS PUBLIC", allResp);
+                // mapTypes = allResp.filter(elem => elem.mapType != null && elem.mapType !== "").map(elem => elem.mapType);
 
                 mapTiles = allResp.map((elem) => ({
@@ -88,6 +99,10 @@
                     rows: 1,
                     isFavorite: false,
+                    type: elem.mapType,
                 }));
             }
+
+            console.log("TYPES:", mapTypes);
+            setMapFilters(mapTypes);
 
             loadedTiles = [...mapTiles];
@@ -114,5 +129,5 @@
 
         const updatedTiles = tiles.map((tile) =>
-            tile.text === tileName ? { ...tile, isFavorite: !tile.isFavorite } : tile
+            tile.text === tileName ? {...tile, isFavorite: !tile.isFavorite} : tile
         );
 
@@ -140,4 +155,18 @@
     };
 
+    const onFilter = (selectedFilter) => {
+        setFilter(selectedFilter);
+
+        if (selectedFilter === "all") {
+            // Show all tiles
+            setTiles(loadedTiles);
+        } else {
+            // Filter tiles by selected type
+            const filteredTiles = loadedTiles.filter((tile) => tile.type === selectedFilter);
+            setTiles(filteredTiles);
+        }
+    };
+
+
     return (
         <div className={styles.container}>
@@ -152,12 +181,16 @@
                     onChange={handleSearchChange}
                 />
+
             </div>
-
+            <div className={styles.filterBar}>
+            <FilterMaps mapTypes={mapFilters} setFilter={onFilter}></FilterMaps>
+            </div>
+            {filter !== "all" && tiles.length === 0 && <p>No maps of type {filter} found</p>}
             <TilesContainer
                 data={tiles}
-                renderTile={(props) => renderTile({ ...props, toggleFavorite })}
+                renderTile={(props) => renderTile({...props, toggleFavorite})}
                 tileSize={tileSize}
-                forceTileWidth={150}
-                forceTileHeight={170}
+                forceTileWidth={170}
+                forceTileHeight={200}
             />
         </div>
